//------------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "UnitUDPSocket.h"
#pragma package(smart_init)
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
__fastcall TUDPMulticastSocket::TUDPMulticastSocket(TComponent* aOwner)
{
        Owner = dynamic_cast<TWinControl*>(aOwner);
        Handle = Owner->Handle;
        Port = DEFAULT_MCASTPORT;
        Address = DEFAULT_MCASTADDR;
        LoopBack = true;

//        LoopBack = false;

        ReceiveBufferSize = DEFAULT_BUFSIZE;

        ReceiveBuffer = new CHAR[ReceiveBufferSize];
        ZeroMemory(ReceiveBuffer,ReceiveBufferSize);

        INT ret;
        AnsiString retstr = "";
        if(ret = CreateSock())
        {       retstr = "Error "+IntToStr(ret);
                ERRMBOX(Handle,retstr.c_str());
        };
        if(ret = PrepareDataReceive(Handle))
        {       retstr = "Error "+IntToStr(ret);
                ERRMBOX(Handle,retstr.c_str());
        };
};
//------------------------------------------------------------------------------
__fastcall TUDPMulticastSocket::~TUDPMulticastSocket()
{       SAFE_DELETE_ARRAY(ReceiveBuffer);
        closesocket(SockM);
        closesocket(Sock);
        WSACleanup();
};
//------------------------------------------------------------------------------
INT __fastcall TUDPMulticastSocket::CreateSock()
{       DWORD dwInterface,          // Local interface to bind to
        dwMulticastGroup;           // Multicast group to join
        short iPort;                // Port number to use
        WSADATA             wsd;
        struct sockaddr_in  local, remote;
        INT     optval, ret=0;

        dwInterface = INADDR_ANY;
        dwMulticastGroup = inet_addr(Address.c_str());
        iPort = Port;

        if (WSAStartup(MAKEWORD(2, 2), &wsd) != 0)
        {       ret = WSAGetLastError();
                closesocket(Sock);
                WSACleanup();
                return ret;
        };
    // Create the socket. In Winsock 2 you do have to specify the
    // multicast attributes that this socket will be used with.
    //
        if ((Sock = WSASocket(AF_INET, SOCK_DGRAM, 0, NULL, 0,
                                    WSA_FLAG_MULTIPOINT_C_LEAF
				  | WSA_FLAG_MULTIPOINT_D_LEAF
				  | WSA_FLAG_OVERLAPPED)) == INVALID_SOCKET)
        {       ret = WSAGetLastError();
                closesocket(Sock);
                WSACleanup();
                return ret;
        };
    // Bind to the local interface. This is done to receive data.
        local.sin_family = AF_INET;
        local.sin_port   = htons(iPort);
        local.sin_addr.s_addr = dwInterface;

        if (bind(Sock, (struct sockaddr *)&local,
                sizeof(local)) == SOCKET_ERROR)
        {       ret = WSAGetLastError();
                closesocket(Sock);
                WSACleanup();
                return ret;
        };
    // Setup the SOCKADDR_IN structure describing the multicast
    // group we want to join
    //
        remote.sin_family      = AF_INET;
        remote.sin_port        = htons(iPort);
        remote.sin_addr.s_addr = dwMulticastGroup;
    //
    // Change the TTL to something more appropriate
    //
        optval = 8;
        if (setsockopt(Sock, IPPROTO_IP, IP_MULTICAST_TTL,
                (char *)&optval, sizeof(int)) == SOCKET_ERROR)
        {       ret = WSAGetLastError();
                closesocket(Sock);
                WSACleanup();
                return ret;
        };
    // Disable loopback if needed
        if (!LoopBack)
        {       optval = 0;
                if (setsockopt(Sock, IPPROTO_IP, IP_MULTICAST_LOOP,
                    (char *)&optval, sizeof(optval)) == SOCKET_ERROR)
                {       ret = WSAGetLastError();
                        closesocket(Sock);
                        WSACleanup();
                        return ret;
                };
        };
    // Join the multicast group.  Note that sockM is not used 
    // to send or receive data. It is used when you want to 
    // leave the multicast group. You simply call closesocket() 
    // on it.
        if ((SockM = WSAJoinLeaf(Sock, (SOCKADDR *)&remote,
                sizeof(remote), NULL, NULL, NULL, NULL,
                JL_BOTH)) == INVALID_SOCKET)
        {       ret = WSAGetLastError();
                closesocket(Sock);
                WSACleanup();
                return ret;
        };

        return 0;
};
//------------------------------------------------------------------------------
INT __fastcall TUDPMulticastSocket::PrepareDataReceive(HANDLE aWindowHandle)
{       INT ret;
        if ((ret = WSAAsyncSelect(Sock,aWindowHandle,WM_SOCKET,FD_READ | FD_OOB)) == SOCKET_ERROR)
        {       ret = WSAGetLastError();
                WSACleanup();
                return ret;
        };
        return 0;
};
//------------------------------------------------------------------------------
INT __fastcall TUDPMulticastSocket::Send(PCHAR aBuffer, INT aBufLength)
{       INT ret;
        if (send(Sock,aBuffer,aBufLength,0) == SOCKET_ERROR)
        {       ret = WSAGetLastError();
                WSACleanup();
                return ret;
        };
        return 0;        
};
//------------------------------------------------------------------------------
